--[[	Detailed Durability - Durability Text Module
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

local AddOn=select(2,...);

--------------------------
--[[	Text Setup	]]
--------------------------
local DurabilityText=DurabilityFrame:CreateFontString(nil,"OVERLAY","NumberFont_GameNormal");
DurabilityText:SetPoint("TOPRIGHT",DurabilityHead,"TOPLEFT");
AddOn.ModifyFont(DurabilityText,nil,nil,"OUTLINE");

local BrokenText=DurabilityFrame:CreateFontString(nil,"OVERLAY","SystemFont_Shadow_Med1_Outline");
BrokenText:SetPoint("BOTTOM",DurabilityHead,"TOP",0,2);
BrokenText:SetTextColor(1,0,0);

--------------------------
--[[	Update Function	]]
--------------------------
local function UpdateDurabilityText()
--	Scan Items
	local numbroken,numitems,lowpercent=0,0,nil;
	for _,slot in pairs(AddOn.AlertToInventorySlotMapping) do
		if GetInventoryItemTexture("player",slot) then--	Detect item in inventory slot
			local cur,max=GetInventoryItemDurability(slot);
			if cur and max and not (slot==INVSLOT_RANGED and AddOn.UsesDurabilityForAmmo(GetInventoryItemID("player",slot))) then--	Process if item is destructible
				if cur>0 then lowpercent=math.min(cur/max,lowpercent or 1);--	Store lowest percent
				else numbroken=numbroken+1; end
				numitems=numitems+1;
			end
		end
	end

--	Durability Text
	lowpercent=lowpercent or 0;--	Default to zero if everything is broken
	if numitems>0 then--	We have durability to display
		DurabilityText:SetFormattedText("%.0f%%",lowpercent*100);
		DurabilityText:SetTextColor(AddOn.GetPercentColor(lowpercent));
	else DurabilityText:SetText(nil); end--	Nothing to show here, move along

--	Broken Text
	if numbroken>0 then BrokenText:SetFormattedText(AddOn.Localization.DurabilityText_BrokenCountFormat,numbroken,numitems);
	else BrokenText:SetText(nil); end
end

--------------------------
--[[	Event Handler	]]
--------------------------
local EventFrame=CreateFrame("Frame");
EventFrame:RegisterEvent("PLAYER_LOGIN");--	Login/Reload
EventFrame:RegisterEvent("UPDATE_INVENTORY_DURABILITY");--	Item took durability damage
EventFrame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");--	Primary Equipped/Unequipped/Swapped items (Ammo slot doesn't fire this in TBC)
EventFrame:RegisterUnitEvent("UNIT_INVENTORY_CHANGED","player");--	Backup Equipped/Unequipped/Swapped items
EventFrame:SetScript("OnEvent",UpdateDurabilityText);
