--[[	Detailed Durability - Item Cache Lib
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

local AddOn=select(2,...);

--------------------------
--[[	Item Cache API	]]
--------------------------
local WaitingList={};
function AddOn.RequestItemData(itemid,func)--	Returns true if cached, false if requested, nil if neither
	if itemid and C_Item.DoesItemExistByID(itemid) then
		if C_Item.IsItemDataCachedByID(itemid) then return true; else
			if func then
				local list=WaitingList[itemid]; if list then
					if tIndexOf(list,func) then return nil;
					else table.insert(list,func); end
				else WaitingList[itemid]={func}; end
			end
			C_Item.RequestLoadItemDataByID(itemid);
			return false;
		end
	end
	return nil;
end

--------------------------
--[[	Event Handler	]]
--------------------------
local ItemEventFrame=CreateFrame("Frame");
ItemEventFrame:RegisterEvent("ITEM_DATA_LOAD_RESULT");
ItemEventFrame:SetScript("OnEvent",function(self,_,itemid,success)
	local list=WaitingList[itemid]; if list then
		local errhnd=geterrorhandler();
		WaitingList[itemid]=nil;--	Clear first in case callbacks try to reregister the item while iterating
		for _,func in ipairs(list) do xpcall(func,errhnd,itemid,success); end
	end
end);
